<?php
/************************************************************************
 Codelet Tuning Infrastructure
 Copyright (C) 2010-2015 Intel Corporation, CEA, GENCI, and UVSQ

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
************************************************************************/

// Authors: Franck Talbart, Mathieu Bordet, Nicolas Petit

require_once('Viewer.php');
require_once($_SERVER['DOCUMENT_ROOT'].'../cfg/config.inc.php');
require_once($DIRECTORY['INCLUDE'].'globals.inc.php');
require_once($DIRECTORY['PLUGINS'].'MaqaoCqaResultsPlugin.php');
require_once($DIRECTORY['PLUGINS'].'ViewPlugin.php');

class LibCountingResultsViewer extends Viewer
{
    /**
     *
     * @brief Override parent constructor. Initialises all the parameters.
     * @param params: the array of parameters
     * @param id_table: the next free table index
     * @param info: view plugin data
     */
    function __construct($params, $id_table, $info)
    {
        parent::__construct($params, $id_table, $info);
        $maqao_cqa_results = new MaqaoCqaResultsPlugin();
        $this->uid = $maqao_cqa_results->uid;
    }
    //---------------------------------------------------------------------------
    
    /**
     *
     * @brief Override. Page functions, for better readability
     * @param file: file
     * @param id_table: the next free table index
     * @param uid_data: data uid
     * @param type_file: file type
     * @return the next free table index
     */
    public function echo_tables($file, $id_table, $uid_data, $type_file)
    {
        foreach ($file as $cmd => $content)
        {
            ?>
                <h2>
                    Plugin command =
                    <i><?php echo htmlspecialchars($cmd);?></i>
            <?php
            
            if (isset($content->attributes->{META_ATTRIBUTE_DESC}))
            {
                ?>
                    ; Description =
                    <i><?php echo $content->attributes->{META_ATTRIBUTE_DESC};?></i>
                <?php
            }
            ?>
                </h2>
            <?php

            //The lib counting results are generated by a lib counting entry.
            //We retrieve the uarch and the counters given in this lib counting
            //entry to display only the relevant information in the tables
            //(i.e. only the table for the target architecture and the counters
            //specified in the lib counting entry).
            $uarch = '';
            $counters = array();

            $view_plugin = new ViewPlugin();

            //Getting the lib counting group id from the lib counting results entry.
            $lib_counting_results = $view_plugin->get_data('data', array('data_uid' => $uid_data));
            $lib_counting_group_uid = '';
            foreach ($lib_counting_results->output_file->init->params as $param)
            {
                if($param->{META_ATTRIBUTE_NAME} == 'lib_counting_group')
                {
                    $lib_counting_group_uid = $param->{META_ATTRIBUTE_VALUE};
                }
            }

            //Getting the lib counting id from the lib countign group entry.
            $lib_counting_group = $view_plugin->get_data('data', array('data_uid' => $lib_counting_group_uid));
            $lib_counting_uid = '';
            foreach ($lib_counting_group->output_file->init->params as $param)
            {
                if($param->{META_ATTRIBUTE_NAME} == 'lib_counting')
                {
                    $lib_counting_uid = $param->{META_ATTRIBUTE_VALUE};
                }
            }
            
            //Now, we can explore the lib counting entry and retrieve the uarch and counters parameters.
            $lib_counting = $view_plugin->get_data('data', array('data_uid' => $lib_counting_uid));
            foreach ($lib_counting->output_file->init->params as $param)
            {
                if($param->{META_ATTRIBUTE_NAME} == 'uarch')
                {
                    $uarch = $param->{META_ATTRIBUTE_VALUE};
                }
                else if($param->{META_ATTRIBUTE_NAME} == 'counter_list')
                {
                    //The counters list is formatted as follows in the lib counting output file: <counter_name>:<value>
                    //But it look like this in the lib counting results output_file: <counter_name>_<value>
                    //So, we replace the ":" by a "_" to match these lists.
                    foreach ($param->{META_ATTRIBUTE_VALUE} as $counter)
                    {
                        $counters[] = str_replace(':', '_', $counter);
                    }
                }
            }

            //If the counters list is empty, we have to display all the counters for the given architecture.
            if(sizeof($counters) == 0)
            {
                $all_counters = array();
                
                //Getting all the counters from the lib counting results entry.
                foreach ($lib_counting_results->input_default->init->params as $param)
                {
                    if($param->{META_ATTRIBUTE_NAME} == 'counters')
                    {
                        $all_counters = $param->{META_ATTRIBUTE_MATRIX_COLUMN_NAMES};
                    }
                }

                //Keeping only the counters referring to the given architecture.
                foreach($all_counters as $counter)
                {
                    //If the current counter is relative to the given architecture.
                    if(strpos($counter, $uarch) !== false)
                    {
                        //Removing the prefix specifying the architecture to the name of the counter and add it to the counters list.
                        $counters[] = substr($counter, strlen($uarch)+1);
                    }
                }
            }

            $contents_common = array();
            $contents_file = array();
            $contents_matrixes = array();
            
            foreach($content->params as $index => $param)
            {
                if($param->{META_ATTRIBUTE_TYPE} == META_CONTENT_ATTRIBUTE_TYPE_FILE)
                {
                    $contents_file[] = $param;
                }
                else if($param->{META_ATTRIBUTE_TYPE} == META_CONTENT_ATTRIBUTE_TYPE_MATRIX)
                {
                    $content_matrixes[$param->{META_ATTRIBUTE_NAME}] = $param;
                }
                else
                {
                    $contents_common[] = $param;
                }
            }

            
            $matrix_tables = array();

            //Filling the counters table for the given architecture.
            if (array_key_exists('counters', $content_matrixes))
            {
                $current_matrix = $content_matrixes['counters'];
                
                //Changing the matrix data into several acceptable tables of params.
                foreach($current_matrix->{META_ATTRIBUTE_MATRIX_COLUMN_NAMES} as $index => $cname)
                {
                    //Removing the prefix specifying the architecture to the name of the counter.
                    $cname_without_uarch_prefix = substr($cname, strlen($uarch)+1);
                    
                    if(in_array($cname_without_uarch_prefix, $counters))
                    {
                        $current_params = (object) array(
                            META_ATTRIBUTE_NAME => $cname,
                            META_ATTRIBUTE_LIST => True,
                            META_ATTRIBUTE_DESC => $current_matrix->{META_ATTRIBUTE_MATRIX_COLUMN_DESCS}[$index],
                            META_ATTRIBUTE_LONG_DESC => $current_matrix->{META_ATTRIBUTE_MATRIX_COLUMN_LONG_DESCS}[$index],
                            META_ATTRIBUTE_TYPE => $current_matrix->{META_ATTRIBUTE_MATRIX_COLUMN_TYPES}[$index],
                            META_ATTRIBUTE_VALUE => $current_matrix->{META_ATTRIBUTE_VALUE}->$cname
                        );
                        
                        $matrix_tables[$uarch][] = $current_params;
                    }
                }
                unset($content_matrixes['counters']);
            }
           
            $matrix_tables[$uarch] = $this->generate_table_data($matrix_tables[$uarch], $uid_data);
            
            //Filling the metrics table for the given architecture.
            if (array_key_exists('metrics', $content_matrixes))
            {
                $current_matrix = $content_matrixes['metrics'];
                $current_params = array();
                
                //Changing the matrix data into an acceptable table of params.
                foreach($current_matrix->{META_ATTRIBUTE_MATRIX_COLUMN_NAMES} as $index => $cname)
                {
                    //If the metric if relative to the given architecture.
                    if(strpos($cname, $uarch) !== false)
                    {
                        $current_params[] = (object) array(
                            META_ATTRIBUTE_NAME => $cname,
                            META_ATTRIBUTE_LIST => True,
                            META_ATTRIBUTE_DESC => $current_matrix->{META_ATTRIBUTE_MATRIX_COLUMN_DESCS}[$index],
                            META_ATTRIBUTE_LONG_DESC => $current_matrix->{META_ATTRIBUTE_MATRIX_COLUMN_LONG_DESCS}[$index],
                            META_ATTRIBUTE_TYPE => $current_matrix->{META_ATTRIBUTE_MATRIX_COLUMN_TYPES}[$index],
                            META_ATTRIBUTE_VALUE => $current_matrix->{META_ATTRIBUTE_VALUE}->$cname
                        );
                    }
                }
                $matrix_tables[$current_matrix->{META_ATTRIBUTE_NAME}] = $this->generate_table_data($current_params, $uid_data);
            }
            
            $table_common = $this->generate_table_data($contents_common, $uid_data);

            ?>
                <div class="full-view-space"></div>
                <div class="block" style="width: 75%;">
                    <?php cts_table_create($this->id_table, $table_common);?>
                </div>
            <?php
            $this->id_table += 1;
            ?>
                <div class="full-view-space"></div>
                <div style="width: 75%;"><button style="position:relative; left:50%" id="toggle_table_other_button">More</button></div>
                
                <div id="table_maqao_cqa_results_other">
                <?php
                $this->id_table += 1;
                
                //Displaying matrix tables contents
                foreach($matrix_tables as $indice => $matrix_table)
                {
                    ?>
                        <h1 style="border-bottom: 0;">
                            <?php echo $indice; ?>
                        </h1>
                        <div class="block" style="width: 75%;">
                            <?php cts_table_create($this->id_table, $matrix_table);?>
                        </div>
                    <?php
                    $this->id_table += 1;
                }
                ?>
                </div>
                
                <script type="text/javascript">
                   $(document).ready(function() {
                       $('#toggle_table_other_button').click(function () {
                           toggle_object($('div#table_maqao_cqa_results_other'));
                       });
                       $('div#table_maqao_cqa_results_other').hide();
                    });
               </script>
                
        <?php
        }
        return $this->id_table;
    }
    //---------------------------------------------------------------------------
    
    /**
     *
     * @brief Override. Print the HTML code for all the page
     */
    public function html()
    {
        $this->script();
        $this->toolbar();
        $this->actions();
        $this->header();
        $this->output_file();
        $this->file_content();
        $this->additional_files();
        $this->note();
        $this->tag();
        $this->information();
    }
}
